Index: issm/trunk/src/c/analyses/analyses.h
===================================================================
--- issm/trunk/src/c/analyses/analyses.h	(revision 25994)
+++ issm/trunk/src/c/analyses/analyses.h	(revision 26744)
@@ -1,4 +1,4 @@
 /*
- * analyses.h: 
+ * analyses.h:
  */
 
@@ -23,5 +23,4 @@
 #include "./FreeSurfaceBaseAnalysis.h"
 #include "./FreeSurfaceTopAnalysis.h"
-#include "./GiaAnalysis.h"
 #include "./GLheightadvectionAnalysis.h"
 #include "./LoveAnalysis.h"
@@ -30,4 +29,5 @@
 #include "./HydrologyDCInefficientAnalysis.h"
 #include "./HydrologyShreveAnalysis.h"
+#include "./HydrologyTwsAnalysis.h"
 #include "./HydrologyGlaDSAnalysis.h"
 #include "./HydrologyShaktiAnalysis.h"
@@ -35,6 +35,8 @@
 #include "./LevelsetAnalysis.h"
 #include "./MasstransportAnalysis.h"
+#include "./OceantransportAnalysis.h"
+#include "./SamplingAnalysis.h"
 #include "./SmbAnalysis.h"
-#include "./SealevelriseAnalysis.h"
+#include "./SealevelchangeAnalysis.h"
 #include "./MeltingAnalysis.h"
 #include "./SmoothAnalysis.h"
Index: issm/trunk/src/c/classes/BarystaticContributions.cpp
===================================================================
--- issm/trunk/src/c/classes/BarystaticContributions.cpp	(revision 26744)
+++ issm/trunk/src/c/classes/BarystaticContributions.cpp	(revision 26744)
@@ -0,0 +1,185 @@
+/*!\file BarystaticContributions.c
+ * \brief: implementation of the BarystaticContributions object
+ */
+
+/*Include files: {{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "./BarystaticContributions.h" 
+#include "../toolkits/toolkits.h"
+#include "./classes.h"
+/*}}}*/
+
+/*Constructors and destructors:*/
+BarystaticContributions::BarystaticContributions(IoModel* iomodel ){ /*{{{*/
+
+	int nel;
+
+	iomodel->FetchData(&nice,"md.solidearth.npartice");
+	if(nice){
+		iomodel->FetchData(&pice,&nel,NULL,"md.solidearth.partitionice");
+		ice=new Vector<IssmDouble>(nice);
+		cumice=new Vector<IssmDouble>(nice); cumice->Set(0); cumice->Assemble();
+	}
+	else{
+		ice=new Vector<IssmDouble>(1);
+		cumice=new Vector<IssmDouble>(1);
+	}
+
+	iomodel->FetchData(&nhydro,"md.solidearth.nparthydro");
+	if(nhydro){
+		iomodel->FetchData(&phydro,&nel,NULL,"md.solidearth.partitionhydro");
+		hydro=new Vector<IssmDouble>(nhydro);
+		cumhydro=new Vector<IssmDouble>(nhydro); cumhydro->Set(0); cumhydro->Assemble();
+	}
+	else{
+		hydro=new Vector<IssmDouble>(1);
+		cumhydro=new Vector<IssmDouble>(1);
+	}
+	iomodel->FetchData(&nocean,"md.solidearth.npartocean");
+	if(nocean){
+		iomodel->FetchData(&pocean,&nel,NULL,"md.solidearth.partitionocean");
+		ocean=new Vector<IssmDouble>(nocean);
+		cumocean=new Vector<IssmDouble>(nocean); cumocean->Set(0); cumocean->Assemble();
+	}
+	else{
+		ocean=new Vector<IssmDouble>(1);
+		cumocean=new Vector<IssmDouble>(1);
+	}
+
+} /*}}}*/
+BarystaticContributions::~BarystaticContributions(){ /*{{{*/
+	delete ice;   delete cumice;
+	delete hydro; delete cumhydro;
+	delete ocean; delete cumocean;
+	if(nice)xDelete<IssmDouble>(pice);
+	if(nhydro)xDelete<IssmDouble>(phydro);
+	if(nocean)xDelete<IssmDouble>(pocean);
+}; /*}}}*/
+
+/*Support routines:*/
+IssmDouble BarystaticContributions::Total(){ /*{{{*/
+
+	IssmDouble  sumice,sumhydro,sumocean;
+
+	ice->Assemble();
+	hydro->Assemble();
+	ocean->Assemble();
+
+	ice->Sum(&sumice);
+	hydro->Sum(&sumhydro);
+	ocean->Sum(&sumocean);
+
+	return sumice+sumhydro+sumocean;
+
+} /*}}}*/
+IssmDouble BarystaticContributions::CumTotal(){ /*{{{*/
+
+	IssmDouble sumice,sumhydro,sumocean;
+
+	cumice->Assemble();
+	cumhydro->Assemble();
+	cumocean->Assemble();
+
+	cumice->Sum(&sumice);
+	cumhydro->Sum(&sumhydro);
+	cumocean->Sum(&sumocean);
+
+	return sumice+sumhydro+sumocean;
+
+} /*}}}*/
+void BarystaticContributions::Cumulate(Parameters* parameters){ /*{{{*/
+
+	cumice->AXPY(ice,1);
+	cumocean->AXPY(ocean,1);
+	cumhydro->AXPY(hydro,1);
+
+} /*}}}*/
+void BarystaticContributions::Set(int eid, IssmDouble icevalue, IssmDouble hydrovalue, IssmDouble oceanvalue){ /*{{{*/
+
+	int id;
+	if(nice){
+		id=reCast<int>(pice[eid]);
+		ice->SetValue(id,icevalue,ADD_VAL);
+	}
+	else{
+		ice->SetValue(0,icevalue,ADD_VAL);
+	}
+
+	if(nhydro){
+		id=reCast<int>(phydro[eid]);
+		hydro->SetValue(id,hydrovalue,ADD_VAL);
+	}
+	else{
+		hydro->SetValue(0,hydrovalue,ADD_VAL);
+	}
+
+	if(nocean){
+		id=reCast<int>(pocean[eid]);
+		ocean->SetValue(id,oceanvalue,ADD_VAL);
+	}
+	else{
+		ocean->SetValue(0,oceanvalue,ADD_VAL);
+	}
+
+} /*}}}*/
+void BarystaticContributions::Reset(){ /*{{{*/
+
+	ice->Set(0.);
+	hydro->Set(0.);
+	ocean->Set(0.);
+
+} /*}}}*/
+void BarystaticContributions::Save(Results* results, Parameters* parameters, IssmDouble oceanarea){ /*{{{*/
+
+	int        step;
+	IssmDouble time;
+	IssmDouble rho_water;
+
+	IssmDouble* cumice_serial=NULL;
+	IssmDouble* cumhydro_serial=NULL;
+	IssmDouble* cumocean_serial=NULL;
+
+	IssmDouble sumice,sumhydro,sumocean;
+
+	parameters->FindParam(&step,StepEnum);
+	parameters->FindParam(&time,TimeEnum);
+	parameters->FindParam(&rho_water,MaterialsRhoSeawaterEnum);
+
+	ice->Sum(&sumice); hydro->Sum(&sumhydro); ocean->Sum(&sumocean);
+	results->AddResult(new GenericExternalResult<IssmDouble>(results->Size()+1,BslcEnum,this->Total()/oceanarea/rho_water,step,time));
+	results->AddResult(new GenericExternalResult<IssmDouble>(results->Size()+1,BslcIceEnum,sumice/oceanarea/rho_water,step,time));
+	results->AddResult(new GenericExternalResult<IssmDouble>(results->Size()+1,BslcHydroEnum,sumice/oceanarea/rho_water,step,time));
+	results->AddResult(new GenericExternalResult<IssmDouble>(results->Size()+1,BslcOceanEnum,sumocean/oceanarea/rho_water,step,time));
+
+	cumice->Sum(&sumice); cumhydro->Sum(&sumhydro); cumocean->Sum(&sumocean);
+	results->AddResult(new GenericExternalResult<IssmDouble>(results->Size()+1,CumBslcEnum,this->CumTotal()/oceanarea/rho_water,step,time));
+	results->AddResult(new GenericExternalResult<IssmDouble>(results->Size()+1,CumBslcIceEnum,sumice/oceanarea/rho_water,step,time));
+	results->AddResult(new GenericExternalResult<IssmDouble>(results->Size()+1,CumBslcHydroEnum,sumhydro/oceanarea/rho_water,step,time));
+	results->AddResult(new GenericExternalResult<IssmDouble>(results->Size()+1,CumBslcOceanEnum,sumocean/oceanarea/rho_water,step,time));
+
+	if(nice){
+		cumice_serial=this->cumice->ToMPISerial0(); for (int i=0;i<nice;i++)cumice_serial[i]=cumice_serial[i]/oceanarea/rho_water;
+		results->AddResult(new GenericExternalResult<IssmDouble*>(results->Size()+1,CumBslcIcePartitionEnum,cumice_serial,nice,1,step,time));
+	}
+	if(nhydro){
+		cumhydro_serial=this->cumhydro->ToMPISerial0(); for (int i=0;i<nhydro;i++)cumhydro_serial[i]=cumhydro_serial[i]/oceanarea/rho_water;
+		results->AddResult(new GenericExternalResult<IssmDouble*>(results->Size()+1,CumBslcHydroPartitionEnum,cumhydro_serial,nhydro,1,step,time));
+	}
+	if(nocean){
+		cumocean_serial=this->cumocean->ToMPISerial0(); for (int i=0;i<nocean;i++)cumocean_serial[i]=cumocean_serial[i]/oceanarea/rho_water;
+		results->AddResult(new GenericExternalResult<IssmDouble*>(results->Size()+1,CumBslcOceanPartitionEnum,cumocean_serial,nocean,1,step,time));
+	}
+
+	if(IssmComm::GetRank()==0){
+		if(nice)xDelete<IssmDouble>(cumice_serial);
+		if(nhydro)xDelete<IssmDouble>(cumhydro_serial);
+		if(nocean)xDelete<IssmDouble>(cumocean_serial);
+	}
+	return;
+
+} /*}}}*/
Index: issm/trunk/src/c/classes/BarystaticContributions.h
===================================================================
--- issm/trunk/src/c/classes/BarystaticContributions.h	(revision 26744)
+++ issm/trunk/src/c/classes/BarystaticContributions.h	(revision 26744)
@@ -0,0 +1,47 @@
+/*!\file BarystaticContributions.h
+ * \brief: header file for barystatic contribution object
+ */
+
+#ifndef _BARYSTATICCONTRIBUTIONS_H_
+#define _BARYSTATICCONTRIBUTIONS_H_
+
+/*Headers:*/
+class IoModel;
+class Parameters;
+class Results;
+template <class doubletype> class Vector;
+#include "../shared/shared.h"
+
+class BarystaticContributions {
+
+	public: 
+
+		Vector<IssmDouble>* ice;  //contributions to every ice partition (size nice x 1)
+		Vector<IssmDouble>* cumice;  //cumulated contributions to every ice partition
+		int                 nice; //number of ice partitions 
+		IssmDouble*         pice; //ice partition (nel)
+
+		Vector<IssmDouble>* hydro;  //contributions to every hydro partition (size nhydro x 1)
+		Vector<IssmDouble>* cumhydro;  //cumulated contributions to every hydro partition
+		int                 nhydro; //number of hydro partitions 
+		IssmDouble*         phydro; //hydro partition (nel)
+
+		Vector<IssmDouble>* ocean;  //contributions to every ocean partition (size nocean x 1)
+		Vector<IssmDouble>* cumocean;  //cumulated contributions to every ocean partition
+		int                 nocean; //number of ocean partitions 
+		IssmDouble*         pocean; //ocean partition (nel)
+
+		/*BarystaticContributions constructors, destructors :*/
+		BarystaticContributions(IoModel* iomodel );
+		~BarystaticContributions();
+
+		/*routines:*/
+		IssmDouble Total();
+		IssmDouble CumTotal();
+		void Cumulate(Parameters* parameters);
+		void Save(Results* results, Parameters* parameters, IssmDouble oceanarea);
+		void Set(int eid, IssmDouble icevalue, IssmDouble hydrovalue, IssmDouble oceanvalue);
+		void Reset();
+
+};
+#endif  /* _BARYSTATICCONTRIBUTIONS_H_ */
Index: issm/trunk/src/c/classes/Cfdragcoeffabsgrad.cpp
===================================================================
--- issm/trunk/src/c/classes/Cfdragcoeffabsgrad.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Cfdragcoeffabsgrad.cpp	(revision 26744)
@@ -161,5 +161,5 @@
 
 	/*clean up and Return: */
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	xDelete<IssmDouble>(xyz_list);
 	delete gauss;
Index: issm/trunk/src/c/classes/Cflevelsetmisfit.cpp
===================================================================
--- issm/trunk/src/c/classes/Cflevelsetmisfit.cpp	(revision 26744)
+++ issm/trunk/src/c/classes/Cflevelsetmisfit.cpp	(revision 26744)
@@ -0,0 +1,215 @@
+/*!\file Cflevelsetmisfit.cpp
+ * \brief: Cflevelsetmisfit Object
+ */
+
+/*Headers:*/
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+   #include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "./classes.h"
+#include "./ExternalResults/ExternalResult.h"
+#include "./ExternalResults/Results.h"
+#include "../datastructures/datastructures.h"
+#include "./Elements/Element.h"
+#include "./Elements/Elements.h"
+#include "./FemModel.h"
+#include "../modules/SurfaceAreax/SurfaceAreax.h"
+#include "../classes/Params/Parameters.h"
+#include "../classes/gauss/Gauss.h"
+#include "./Inputs/DatasetInput.h"
+/*}}}*/
+
+/*Cflevelsetmisfit constructors, destructors :*/
+Cflevelsetmisfit::Cflevelsetmisfit(){/*{{{*/
+
+	this->definitionenum = -1;
+	this->name = NULL;
+	this->model_enum = UNDEF;
+	this->observation_enum = UNDEF;
+	this->weights_enum = UNDEF;
+	this->misfit=0;
+	this->datatime=0.;
+	this->timepassedflag = false;
+}
+/*}}}*/
+Cflevelsetmisfit::Cflevelsetmisfit(char* in_name, int in_definitionenum, int in_model_enum, int in_observation_enum, int in_weights_enum, IssmDouble in_datatime, bool in_timepassedflag){/*{{{*/
+
+	this->definitionenum=in_definitionenum;
+
+	this->name		= xNew<char>(strlen(in_name)+1);
+	xMemCpy<char>(this->name,in_name,strlen(in_name)+1);
+
+	this->model_enum=in_model_enum;
+	this->observation_enum=in_observation_enum;
+	this->weights_enum=in_weights_enum;
+	this->datatime=in_datatime;
+	this->timepassedflag=in_timepassedflag;
+
+	this->misfit=0;
+}
+/*}}}*/
+Cflevelsetmisfit::~Cflevelsetmisfit(){/*{{{*/
+	if(this->name)xDelete(this->name);
+	this->misfit=0;
+}
+/*}}}*/
+/*Object virtual function resolutoin: */
+Object* Cflevelsetmisfit::copy() {/*{{{*/
+	Cflevelsetmisfit* mf = new Cflevelsetmisfit(this->name,this->definitionenum, this->model_enum,this->observation_enum,this->weights_enum,this->datatime,this->timepassedflag);
+	mf->misfit=this->misfit;
+	return (Object*) mf;
+}
+/*}}}*/
+void Cflevelsetmisfit::DeepEcho(void){/*{{{*/
+	this->Echo();
+}
+/*}}}*/
+void Cflevelsetmisfit::Echo(void){/*{{{*/
+	_printf_(" Cflevelsetmisfit: " << name << " " << this->definitionenum << "\n");
+	_printf_("    model_enum: " << model_enum << " " << EnumToStringx(model_enum) << "\n");
+	_printf_("    observation_enum: " << observation_enum << " " << EnumToStringx(observation_enum) << "\n");
+	_printf_("    weights_enum: " << weights_enum << " " << EnumToStringx(weights_enum) << "\n");
+	_printf_("    datatime: " << datatime << "\n");
+	_printf_("	  timepassedflag: "<<timepassedflag<<"\n");
+}
+/*}}}*/
+int Cflevelsetmisfit::Id(void){/*{{{*/
+	return -1;
+}
+/*}}}*/
+void Cflevelsetmisfit::Marshall(MarshallHandle* marshallhandle){/*{{{*/
+
+	/*ok, marshall operations: */
+   int object_enum=CflevelsetmisfitEnum;
+   marshallhandle->call(object_enum);
+
+	marshallhandle->call(this->definitionenum);
+	marshallhandle->call(this->model_enum);
+	marshallhandle->call(this->name);
+	marshallhandle->call(this->observation_enum);
+	marshallhandle->call(this->weights_enum);
+	marshallhandle->call(this->datatime);
+	marshallhandle->call(this->timepassedflag);
+	marshallhandle->call(this->misfit);
+} 
+/*}}}*/
+int Cflevelsetmisfit::ObjectEnum(void){/*{{{*/
+	return CflevelsetmisfitEnum;
+}
+/*}}}*/
+/*Definition virtual function resolutoin: */
+int Cflevelsetmisfit::DefinitionEnum(){/*{{{*/
+	return this->definitionenum;
+}
+/*}}}*/
+char* Cflevelsetmisfit::Name(){/*{{{*/
+	char* name2=xNew<char>(strlen(this->name)+1);
+	xMemCpy(name2,this->name,strlen(this->name)+1);
+
+	return name2;
+}
+/*}}}*/
+IssmDouble Cflevelsetmisfit::Response(FemModel* femmodel){/*{{{*/
+	 /*diverse: */
+	 IssmDouble time;
+
+	 /*recover time parameters: */
+	 femmodel->parameters->FindParam(&time,TimeEnum);
+
+	 IssmDouble J=0.;
+	 IssmDouble J_sum=0.;
+
+	 if(datatime<=time && !timepassedflag){
+		 for(Object* & object : femmodel->elements->objects){
+			 Element* element=xDynamicCast<Element*>(object);
+			 J+=this->Cflevelsetmisfit_Calculation(element,model_enum,observation_enum,weights_enum);
+		 }
+
+		 ISSM_MPI_Allreduce ( (void*)&J,(void*)&J_sum,1,ISSM_MPI_DOUBLE,ISSM_MPI_SUM,IssmComm::GetComm());
+		 ISSM_MPI_Bcast(&J_sum,1,ISSM_MPI_DOUBLE,0,IssmComm::GetComm());
+		 J=J_sum;
+
+		 timepassedflag = true;
+		 return J;
+	 }
+	 else return J;
+ }
+	/*}}}*/
+IssmDouble Cflevelsetmisfit::Cflevelsetmisfit_Calculation(Element* element, int model_enum, int observation_enum, int weights_enum){/*{{{*/
+
+	int        domaintype,numcomponents;
+	IssmDouble Jelem=0.;
+	IssmDouble misfit,Jdet;
+	IssmDouble model,obs,weight;
+	IssmDouble modelLevel,obsLevel;
+	IssmDouble* xyz_list = NULL;
+
+	/*Get basal element*/
+	if(!element->IsOnSurface()) return 0.;
+
+	/*If on water, return 0: */
+//	if(!element->IsIceInElement()) return 0.;
+
+	/*Get problem dimension*/
+	element->FindParam(&domaintype,DomainTypeEnum);
+	switch(domaintype){
+		case Domain2DverticalEnum:   numcomponents   = 1; break;
+		case Domain3DEnum:           numcomponents   = 2; break;
+		case Domain2DhorizontalEnum: numcomponents   = 2; break;
+		default: _error_("not supported yet");
+	}
+
+	/*Spawn surface element*/
+	Element* topelement = element->SpawnTopElement();
+
+	/* Get node coordinates*/
+	topelement->GetVerticesCoordinates(&xyz_list);
+
+	/*Retrieve all inputs we will be needing: */
+	DatasetInput *datasetinput = topelement->GetDatasetInput(definitionenum); _assert_(datasetinput);
+	Input        *model_input  = topelement->GetInput(model_enum);            _assert_(model_input);
+
+	/* Start  looping on the number of gaussian points: */
+	Gauss* gauss=topelement->NewGauss(2);
+	while(gauss->next()){
+
+		/* Get Jacobian determinant: */
+		topelement->JacobianDeterminant(&Jdet,xyz_list,gauss);
+
+		/*Get all parameters at gaussian point*/
+		datasetinput->GetInputValue(&weight,gauss,WeightsLevelsetObservationEnum);
+		model_input->GetInputValue(&model,gauss);
+		datasetinput->GetInputValue(&obs,gauss,LevelsetObservationEnum);
+
+		/*Compute Levelset misfit:
+		 *  J = || H(\phi) - H(\phi_obs)||^2
+		 *                                           */
+//		modelLevel = this->Heaviside(model);
+//		obsLevel = this->Heaviside(obs);
+		modelLevel = model;
+		obsLevel = obs;
+
+		misfit=0.5*(modelLevel-obsLevel)*(modelLevel-obsLevel);
+
+//		if (modelLevel*obsLevel<0.0) {
+		/*Add to cost function*/
+			Jelem+=misfit*weight*Jdet*gauss->weight;
+//		}
+	}
+
+	/*clean up and Return: */
+	if(topelement->IsSpawnedElement()){topelement->DeleteMaterials(); delete topelement;};
+	xDelete<IssmDouble>(xyz_list);
+	delete gauss;
+	return Jelem;
+}/*}}}*/
+IssmDouble Cflevelsetmisfit::Heaviside(IssmDouble x){/*{{{*/
+	if (x>0) return 1.;
+	else if (x<0) return -1.;
+	else return 0.;
+}
+	/*}}}*/
Index: issm/trunk/src/c/classes/Cflevelsetmisfit.h
===================================================================
--- issm/trunk/src/c/classes/Cflevelsetmisfit.h	(revision 26744)
+++ issm/trunk/src/c/classes/Cflevelsetmisfit.h	(revision 26744)
@@ -0,0 +1,49 @@
+/*!\file Cflevelsetmisfit.h
+ * \brief: header file for Cflevelsetmisfit object
+ */
+
+#ifndef _CFLEVELSETMISFIT_H_
+#define _CFLEVELSETMISFIT_H_
+
+/*Headers:*/
+#include "./Definition.h"
+#include "./FemModel.h"
+
+IssmDouble OutputDefinitionsResponsex(FemModel* femmodel,int output_enum);
+void  GetVectorFromInputsx( IssmDouble** pvector, int* pvector_size, FemModel* femmodel,int name);
+
+class Cflevelsetmisfit: public Object, public Definition{
+
+	public: 
+
+		int         definitionenum;
+		int         model_enum;
+		char*       name;
+		int         observation_enum;
+		int         weights_enum;
+		IssmDouble	datatime;
+		bool			timepassedflag;
+
+		IssmDouble  misfit; //value carried over in time.
+
+		/*Cflevelsetmisfit constructors, destructors :*/
+		Cflevelsetmisfit();
+		Cflevelsetmisfit(char* in_name, int in_definitionenum, int in_model_enum, int in_observation_enum, int in_weights_enum, IssmDouble in_datatime, bool timepassedflag);
+		~Cflevelsetmisfit();
+
+		/*Object virtual function resolutoin: */
+		Object* copy();
+		void DeepEcho(void);
+		void Echo(void);
+		int Id(void);
+		void Marshall(MarshallHandle* marshallhandle);
+		int ObjectEnum(void);
+
+		/*Definition virtual function resolutoin: */
+		int DefinitionEnum();
+		char* Name();
+		IssmDouble Response(FemModel* femmodel);
+		IssmDouble Cflevelsetmisfit_Calculation(Element* element, int model_enum, int observation_enum, int weights_enum);
+		IssmDouble Heaviside(IssmDouble x);
+};
+#endif  /* _CFLEVELSETMISFIT_H_ */
Index: issm/trunk/src/c/classes/Cfsurfacelogvel.cpp
===================================================================
--- issm/trunk/src/c/classes/Cfsurfacelogvel.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Cfsurfacelogvel.cpp	(revision 26744)
@@ -96,5 +96,4 @@
 IssmDouble Cfsurfacelogvel::Response(FemModel* femmodel){/*{{{*/
 
-
 	/*recover time parameters: */
 	IssmDouble time;
@@ -198,5 +197,5 @@
 
 	/*clean up and Return: */
-	if(domaintype!=Domain2DhorizontalEnum){topelement->DeleteMaterials(); delete topelement;};
+	if(topelement->IsSpawnedElement()){topelement->DeleteMaterials(); delete topelement;};
 	xDelete<IssmDouble>(xyz_list);
 	delete gauss;
Index: issm/trunk/src/c/classes/Cfsurfacesquare.cpp
===================================================================
--- issm/trunk/src/c/classes/Cfsurfacesquare.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Cfsurfacesquare.cpp	(revision 26744)
@@ -83,5 +83,17 @@
 /*}}}*/
 void Cfsurfacesquare::Marshall(MarshallHandle* marshallhandle){/*{{{*/
-	_error_("not implemented yet!"); 
+
+	int object_enum=CfsurfacesquareEnum;
+	marshallhandle->call(object_enum);
+
+	marshallhandle->call(this->definitionenum);
+	marshallhandle->call(this->local);
+	marshallhandle->call(this->model_enum);
+	marshallhandle->call(this->name);
+	marshallhandle->call(this->observation_enum);
+	marshallhandle->call(this->weights_enum);
+	marshallhandle->call(this->datatime);
+	marshallhandle->call(this->timepassedflag);
+	marshallhandle->call(this->misfit);
 } 
 /*}}}*/
@@ -187,5 +199,5 @@
 
 	/*clean up and Return: */
-	if(domaintype!=Domain2DhorizontalEnum){topelement->DeleteMaterials(); delete topelement;};
+	if(topelement->IsSpawnedElement()){topelement->DeleteMaterials(); delete topelement;};
 	xDelete<IssmDouble>(xyz_list);
 	delete gauss;
Index: issm/trunk/src/c/classes/Cfsurfacesquare.h
===================================================================
--- issm/trunk/src/c/classes/Cfsurfacesquare.h	(revision 25994)
+++ issm/trunk/src/c/classes/Cfsurfacesquare.h	(revision 26744)
@@ -22,16 +22,15 @@
 		char*       name;
 		int         observation_enum;
-		char*       timeinterpolation;
 		int         weights_enum;
 		IssmDouble	datatime;
 		bool			timepassedflag;
-		
+
 		IssmDouble  misfit; //value carried over in time.
-		
+
 		/*Cfsurfacesquare constructors, destructors :*/
 		Cfsurfacesquare();
 		Cfsurfacesquare(char* in_name, int in_definitionenum, int in_model_enum, int in_observation_enum, int in_weights_enum, IssmDouble in_datatime, bool timepassedflag);
 		~Cfsurfacesquare();
-		
+
 		/*Object virtual function resolutoin: */
 		Object* copy();
@@ -41,5 +40,5 @@
 		void Marshall(MarshallHandle* marshallhandle);
 		int ObjectEnum(void);
-		
+
 		/*Definition virtual function resolutoin: */
 		int DefinitionEnum();
Index: issm/trunk/src/c/classes/Constraints/SpcDynamic.cpp
===================================================================
--- issm/trunk/src/c/classes/Constraints/SpcDynamic.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Constraints/SpcDynamic.cpp	(revision 26744)
@@ -18,10 +18,10 @@
 }
 /*}}}*/
-SpcDynamic::SpcDynamic(int spc_id,int spc_nodeid, int spc_dof,int spc_analysis_type){/*{{{*/
+SpcDynamic::SpcDynamic(int spc_id,int spc_nodeid, int spc_dof,IssmDouble value_in,int spc_analysis_type){/*{{{*/
 
 	id           = spc_id;
 	nodeid        = spc_nodeid;
 	dof           = spc_dof;
-	value         = 0;
+	value         = value_in;
 	analysis_type = spc_analysis_type;
 	isset         = false;
Index: issm/trunk/src/c/classes/Constraints/SpcDynamic.h
===================================================================
--- issm/trunk/src/c/classes/Constraints/SpcDynamic.h	(revision 25994)
+++ issm/trunk/src/c/classes/Constraints/SpcDynamic.h	(revision 26744)
@@ -26,5 +26,5 @@
 		/*SpcDynamic constructors, destructors*/
 		SpcDynamic();
-		SpcDynamic(int id_in,int nodeid, int dof,int analysis_type);
+		SpcDynamic(int id_in,int nodeid, int dof,IssmDouble value_in,int analysis_type);
 		~SpcDynamic();
 
Index: issm/trunk/src/c/classes/Dakota/IssmParallelDirectApplicInterface.cpp
===================================================================
--- issm/trunk/src/c/classes/Dakota/IssmParallelDirectApplicInterface.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Dakota/IssmParallelDirectApplicInterface.cpp	(revision 26744)
@@ -55,4 +55,5 @@
 		bool       control_analysis         = false;
 		void     (*solutioncore)(FemModel*) = NULL;
+		void     (*solutionprecore)(FemModel*) = NULL;
 		bool       nodakotacore             = true;
 
@@ -94,6 +95,7 @@
 		responses=xNewZeroInit<IssmDouble>(numFns);
 
-		/*Hack:*/
-		for(int i=0;i<femmodel_init->nummodels;i++) if(femmodel_init->analysis_type_list[i]==SealevelriseAnalysisEnum) sealevelrise_core_geometry(femmodel_init);
+		/*Launch cores that are not used during the uncertainty quantification: */
+		WrapperPreCorePointerFromSolutionEnum(&solutionprecore,femmodel_init->parameters,solution_type);
+		if(solutionprecore)solutionprecore(femmodel_init);
 
 		/*Make a copy of femmodel, so we start this new evaluation run for this specific sample with a brand 
@@ -122,5 +124,5 @@
 		if(VerboseQmu()) _printf0_("compute dakota responses:\n");
 		femmodel->DakotaResponsesx(responses,responses_descriptors,numresponsedescriptors,numFns);
-		
+
 		/*Output results for this iteration: */
 		if(VerboseQmu()) _printf0_("output results for this iteration: \n");
